#pragma once
#include "source2sdk/client/DoorState_t.hpp"
#include "source2sdk/entity2/CEntityIOOutput.hpp"
#include "source2sdk/server/CDynamicProp.hpp"
#include "source2sdk/server/locksound_t.hpp"
#include "source2sdk/source2gen.hpp"
#include <cstddef>
#include <cstdint>

// /////////////////////////////////////////////////////////////
// Module: server
// Created using source2gen - github.com/neverlosecc/source2gen
// /////////////////////////////////////////////////////////////

namespace source2sdk::server
{
    class CBaseEntity;
};

namespace source2sdk::server
{
    // Registered alignment: unknown
    // Alignment: 0x8
    // Standard-layout class: false
    // Size: 0xe10
    // Has VTable
    // Is Abstract
    // MNetworkAssumeNotNetworkable
    // 
    // static metadata: MNetworkExcludeByName "m_flAnimTime"
    // static metadata: MNetworkExcludeByName "m_flexWeight"
    // static metadata: MNetworkExcludeByName "m_blinktoggle"
    // static metadata: MNetworkExcludeByUserGroup "m_flPoseParameter"
    // static metadata: MNetworkExcludeByName "m_animationController.m_flPlaybackRate"
    // static metadata: MNetworkExcludeByUserGroup "overlay_vars"
    // static metadata: MNetworkIncludeByName "m_spawnflags"
    // static metadata: MNetworkVarNames "DoorState_t m_eDoorState"
    // static metadata: MNetworkVarNames "bool m_bLocked"
    // static metadata: MNetworkVarNames "Vector m_closedPosition"
    // static metadata: MNetworkVarNames "QAngle m_closedAngles"
    // static metadata: MNetworkVarNames "CHandle< CBasePropDoor> m_hMaster"
    #pragma pack(push, 1)
    class CBasePropDoor : public server::CDynamicProp
    {
    public:
        [[maybe_unused]] std::uint8_t pad_0xb80[0x10]; // 0xb80
        float m_flAutoReturnDelay; // 0xb90        
        [[maybe_unused]] std::uint8_t pad_0xb94[0x4]; // 0xb94
        // m_hDoorList has a template type with potentially unknown template parameters. You can try uncommenting the field below.
        // CUtlVector<CHandle<server::CBasePropDoor>> m_hDoorList;
        char m_hDoorList[0x18]; // 0xb98        
        int32_t m_nHardwareType; // 0xbb0        
        bool m_bNeedsHardware; // 0xbb4        
        [[maybe_unused]] std::uint8_t pad_0xbb5[0x3]; // 0xbb5
        // metadata: MNetworkEnable
        client::DoorState_t m_eDoorState; // 0xbb8        
        // metadata: MNetworkEnable
        bool m_bLocked; // 0xbbc        
        [[maybe_unused]] std::uint8_t pad_0xbbd[0x3]; // 0xbbd
        // metadata: MNetworkEnable
        Vector m_closedPosition; // 0xbc0        
        // metadata: MNetworkEnable
        QAngle m_closedAngles; // 0xbcc        
        // m_hBlocker has a template type with potentially unknown template parameters. You can try uncommenting the field below.
        // CHandle<server::CBaseEntity> m_hBlocker;
        char m_hBlocker[0x4]; // 0xbd8        
        bool m_bFirstBlocked; // 0xbdc        
        [[maybe_unused]] std::uint8_t pad_0xbdd[0x3]; // 0xbdd
        server::locksound_t m_ls; // 0xbe0        
        bool m_bForceClosed; // 0xc00        
        [[maybe_unused]] std::uint8_t pad_0xc01[0x3]; // 0xc01
        Vector m_vecLatchWorldPosition; // 0xc04        
        // m_hActivator has a template type with potentially unknown template parameters. You can try uncommenting the field below.
        // CHandle<server::CBaseEntity> m_hActivator;
        char m_hActivator[0x4]; // 0xc10        
        [[maybe_unused]] std::uint8_t pad_0xc14[0xc]; // 0xc14
        CUtlSymbolLarge m_SoundMoving; // 0xc20        
        CUtlSymbolLarge m_SoundOpen; // 0xc28        
        CUtlSymbolLarge m_SoundClose; // 0xc30        
        CUtlSymbolLarge m_SoundLock; // 0xc38        
        CUtlSymbolLarge m_SoundUnlock; // 0xc40        
        CUtlSymbolLarge m_SoundLatch; // 0xc48        
        CUtlSymbolLarge m_SoundPound; // 0xc50        
        CUtlSymbolLarge m_SoundJiggle; // 0xc58        
        CUtlSymbolLarge m_SoundLockedAnim; // 0xc60        
        int32_t m_numCloseAttempts; // 0xc68        
        CUtlStringToken m_nPhysicsMaterial; // 0xc6c        
        CUtlSymbolLarge m_SlaveName; // 0xc70        
        // metadata: MNetworkEnable
        // m_hMaster has a template type with potentially unknown template parameters. You can try uncommenting the field below.
        // CHandle<server::CBasePropDoor> m_hMaster;
        char m_hMaster[0x4]; // 0xc78        
        [[maybe_unused]] std::uint8_t pad_0xc7c[0x4]; // 0xc7c
        entity2::CEntityIOOutput m_OnBlockedClosing; // 0xc80        
        entity2::CEntityIOOutput m_OnBlockedOpening; // 0xca8        
        entity2::CEntityIOOutput m_OnUnblockedClosing; // 0xcd0        
        entity2::CEntityIOOutput m_OnUnblockedOpening; // 0xcf8        
        entity2::CEntityIOOutput m_OnFullyClosed; // 0xd20        
        entity2::CEntityIOOutput m_OnFullyOpen; // 0xd48        
        entity2::CEntityIOOutput m_OnClose; // 0xd70        
        entity2::CEntityIOOutput m_OnOpen; // 0xd98        
        entity2::CEntityIOOutput m_OnLockedUse; // 0xdc0        
        entity2::CEntityIOOutput m_OnAjarOpen; // 0xde8        
        
        // Datamap fields:
        // void m_hSoundMoving; // 0xc14
        //  m_ls.sLockedSound; // 0xbe8
        //  m_ls.sUnlockedSound; // 0xbf0
        // void InputOpen; // 0x0
        // CUtlSymbolLarge InputOpenAwayFrom; // 0x0
        // float InputOpenAwayFromActivator; // 0x0
        // void InputClose; // 0x0
        // void InputToggle; // 0x0
        // void InputLock; // 0x0
        // void InputUnlock; // 0x0
        // void InputPlayerOpen; // 0x0
        // void InputPlayerClose; // 0x0
        // void CBasePropDoorDoorOpenMoveDone; // 0x0
        // void CBasePropDoorDoorCloseMoveDone; // 0x0
        // void CBasePropDoorDoorAutoCloseThink; // 0x0
        // void CBasePropDoorDisableAreaPortalThink; // 0x0
    };
    #pragma pack(pop)
    
    // Cannot assert offsets of fields in CBasePropDoor because it is not a standard-layout class
    static_assert(sizeof(CBasePropDoor) == 0xe10);
};
